import greenfoot.Actor;
import greenfoot.util.Location;

import java.util.ArrayList;

/**
 * Write a description of class AutonomousMover here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AutonomousMover extends SmoothMover
{
	protected int destinationX;
	protected int destinationY;
	protected Actor destination;
	protected ArrayList<Location> path;
	protected int pathCurentNode = 0;
	
	protected boolean canStop = true;
	protected float speed = 3;
	protected float rotationSpeed = 6;

	protected float actualSpeed;
	
	public static final int ENGINE_MODE_STAND_BY = 0;
	public static final int ENGINE_MODE_DESTINATION_XY = 1;
	public static final int ENGINE_MODE_DESTINATION_ACTOR = 2;
	public static final int ENGINE_MODE_PATH = 3;

	protected int engineMode = ENGINE_MODE_STAND_BY;

    /**
     * Act - do whatever the AutonomousMover wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
	public void act() {
		switch (engineMode) {
		case ENGINE_MODE_STAND_BY:
			standBy();
			break;
		case ENGINE_MODE_DESTINATION_XY:
			modeDestinationXY();
			break;
		case ENGINE_MODE_DESTINATION_ACTOR:
			modeDestinationActor();
			break;
		case ENGINE_MODE_PATH:
			modePath();
			break;
		}

	}

	protected void standBy(){
		
	}
	protected void modeDestinationXY(){
		if(goTo(destinationX, destinationY)){
			destinationReached();
		}
	}
	protected void modeDestinationActor(){
		if(destination.getWorld() != null){
			if(goTo(destination.getX(), destination.getY())){
				destinationReached();
			} else {
				if(getWorld() != null && getIntersectingObjects(Actor.class).contains(destination)){
					if(GeoTools.getDistance(this, destination) < destination.getImage().getWidth()/2 + this.getImage().getWidth()/2){
						destinationReached();
					}
				}
			}
			
		} else {
			move(speed);
			testEdgesofWord();
		}
	}
	protected void modePath(){
		if(goTo(path.get(pathCurentNode).getX(), path.get(pathCurentNode).getY())){
			pathCurentNode++;
			if(pathCurentNode >= path.size()){
				destinationReached();
			}
		}
	}
	
	protected void destinationReached(){
		engineMode = ENGINE_MODE_STAND_BY;
	}
	protected boolean goTo(int x, int y) {
		double distanceDiff = Math.sqrt(Math.pow(x - getExactX(), 2)
				+ Math.pow(y - getExactY(), 2));
		if (distanceDiff < speed) {
			setLocation(x, y);
			testEdgesofWord();
			return true;
		}
		int targetAngle = getAngelTo(x, y);
		int angleDiff = targetAngle - getRotation();
		if (angleDiff > 180) {
			angleDiff = angleDiff - 360;
		}
		if (angleDiff < -180) {
			angleDiff = angleDiff + 360;
		}
		int rotationDiff = Math.round(rotationSpeed * Math.signum(angleDiff));

		if (Math.abs(rotationDiff) > Math.abs(angleDiff)) {
			rotationDiff = angleDiff;
		}
		if(!canStop && isOnOrbit(angleDiff, x, y)) {
		    rotationDiff = -rotationDiff;
		}
		int newRotation = GeoTools.normalizeAngle(getRotation() + rotationDiff);
		setRotation(newRotation);
		if ((Math.abs(angleDiff) < 90 || !canStop) && (distanceDiff > 20 || angleDiff == 0)) {
			if (distanceDiff < speed) {
				setLocation(x, y);
				testEdgesofWord();
				return true;
			} else {
				move(speed);
				testEdgesofWord();
			}
		}
		return false;
	}
	protected double getOrbitRadius(){
		return (speed/2) / Math.sin(Math.toRadians(Math.abs(rotationSpeed)/2));
	}
	
	protected ExactLocation getLeftOrbitCenter(){
		double radius = getOrbitRadius();
		ExactLocation orbitCenter = new ExactLocation(getExactX(), getExactY());
		GeoTools.move(orbitCenter, getRotation() - 90, radius);
		return orbitCenter;
	}
	
	protected ExactLocation getRightOrbitCenter(){
		double radius = getOrbitRadius();
		ExactLocation orbitCenter = new ExactLocation(getExactX(), getExactY());
		GeoTools.move(orbitCenter, getRotation() + 90, radius);
		return orbitCenter;
	}

	protected boolean isOnOrbit(double rotationDiff, int x, int y){
		if(Math.abs(rotationDiff) < rotationSpeed){
			return false;
		}
		double radius = getOrbitRadius();
		ExactLocation orbitCenter;
		double distance;
		if(rotationDiff > 0){
			orbitCenter = getRightOrbitCenter();
		}
		else {
			orbitCenter = getLeftOrbitCenter();
		}
		distance = GeoTools.getDistance(x, y, orbitCenter.getX(), orbitCenter.getY());				
//		String msg = String.format("c[ %f, %f], P[%f, %f], R=%f, dis=%f", orbitCenter.getX(), orbitCenter.getY(), getExactX(), getExactY(), radius, distance);
//		System.out.println(msg);
	    return distance < radius;
	}
	
	protected void testEdgesofWord(){
		if(getX() == 0 || getX() >= getWorld().getWidth()-2 ||
				getY() == 0 || getY() >= getWorld().getHeight()-2){
			edgeOfWordReached();
		}
	}
	protected void edgeOfWordReached(){
	}

	protected int getAngelTo(int x, int y) {
		return GeoTools.getAngelTo(getExactX(), getExactY(), x, y);
	}
	public void setDestination(int x, int y) {
		destinationX = x;
		destinationY = y;
		engineMode = ENGINE_MODE_DESTINATION_XY;
	}
	
	public void pursuite(Actor a){
		destination = a;
		engineMode = ENGINE_MODE_DESTINATION_ACTOR;
	}
	
	public void moveByPath(ArrayList<Location> path){
		this.path = path;
		engineMode = ENGINE_MODE_PATH;
		pathCurentNode = 0;
	}

	public int getEngineMode() {
		return engineMode;
	}
	
	
}
