import greenfoot.World;
import greenfoot.util.Location;

import java.awt.Dialog.ModalityType;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Random;

import javax.swing.SwingUtilities;

/**
 * Write a description of class Enterprise here.
 * 
 * @author (your name)
 * @version (a version number or a date)
 */
public class Enterprise extends SpaceShip implements WorldListener {
	public static final int MODE_MANUAL_STEARING_ENGINE_OFF = 0;
	public static final int MODE_MANUAL_STEARING_ENGINE_ON = 1;
	public static final int MODE_MANUAL_STEARING_ROTATION_OFF = 0;
	public static final int MODE_MANUAL_STEARING_ROTATION_RIGHT = 1;
	public static final int MODE_MANUAL_STEARING_ROTATION_LEFT = -1;
	protected int manualStearingEngine = MODE_MANUAL_STEARING_ENGINE_OFF;
	protected int manualStearingRotation = MODE_MANUAL_STEARING_ROTATION_OFF;

	protected EnterpriseControlPanel controlPanel = null;
	protected List<Maneuver> maneuvers = new ArrayList<Maneuver>();

	/**
	 * An example of a method - replace this comment with your own
	 * 
	 * @param y
	 *            a sample parameter for a method
	 * @return the sum of x and y
	 */
	public Enterprise() {
		super();
		setName("Enterprise");
		setShieldOn(false);
		ArrayList<Location> m = new ArrayList<Location>();
		m.add(new Location(200, 200));
		m.add(new Location(-200, 200));
		m.add(new Location(400, 0));
		m.add(new Location(0, -200));
		m.add(new Location(0, 0));
		maneuvers.add(new Maneuver("Alfa", m));

		m = new ArrayList<Location>();
		m.add(new Location(-50, 50));
		m.add(new Location(50, 100));
		m.add(new Location(-50, 150));
		m.add(new Location(200, 0));
		m.add(new Location(50, -50));
		m.add(new Location(-50, 50));
		m.add(new Location(10, 0));
		m.add(new Location(20, 0));
		maneuvers.add(new Maneuver("Beta", m));

		m = new ArrayList<Location>();
		m.add(new Location(50, 50));
		m.add(new Location(0, 100));
		m.add(new Location(-50, 50));
		m.add(new Location(50, -50));
		m.add(new Location(0, -100));
		m.add(new Location(-50, -50));
		m.add(new Location(0, 0));
		maneuvers.add(new Maneuver("Gama", m));
	}

	/**
	 * Act - do whatever the Enterprise wants to do. This method is called
	 * whenever the 'Act' or 'Run' button gets pressed in the environment.
	 */
	public void act() {
		super.act();
		if (engineMode == ENGINE_MODE_STAND_BY) {
			if (manualStearingRotation == MODE_MANUAL_STEARING_ROTATION_LEFT) {
				setRotation((int) (getRotation() - rotationSpeed));
			}
			if (manualStearingRotation == MODE_MANUAL_STEARING_ROTATION_RIGHT) {
				setRotation((int) (getRotation() + rotationSpeed));
			}
			if (manualStearingEngine == MODE_MANUAL_STEARING_ENGINE_ON) {
				move(speed);
			}
		}
	}

	@Override
	protected void destinationReached() {
		super.destinationReached();
		updateControlPanel();
	}

	public EnterpriseControlPanel getControlPanel() {
		if (controlPanel == null) {
			controlPanel = new EnterpriseControlPanel();
			controlPanel.setModalityType(ModalityType.MODELESS);
			//controlPanel.setAlwaysOnTop(true);
		}
		return controlPanel;
	}

	@Override
	protected void addedToWorld(World world1) {
		super.addedToWorld(world1);
	}

	@Override
	protected Torpedo torpedoFactoryMethod() {
		return new Torpedo(5, 10, 4, false);
	}

	@Override
	protected Explosion explosionFctoryMethod() {
		return new Explosion(false);
	}

	public void stopAttack() {
		attackTargets.clear();
		updateControlPanel();
	}

	public void attackNearestKlingon() {
		List<SpaceShip> l = getAllClingonCruisers();
		double max = Double.MAX_VALUE;
		SpaceShip nearest = null;
		for (SpaceShip s : l) {
			double dist = GeoTools.getDistance(this, s);
			if (dist < max) {
				max = dist;
				nearest = s;
			}
		}
		stopAttack();
		if (nearest != null) {
			addAttackTarget(nearest);
		}
		updateControlPanel();
	}

	public void attackAllKlingon() {
		List<SpaceShip> l = getAllClingonCruisers();
		stopAttack();
		addAttackTargets(l);
		updateControlPanel();
	}

	@SuppressWarnings("unchecked")
	private List<SpaceShip> getAllClingonCruisers() {
		return (List<SpaceShip>) this.getObjectsInRange(1000,
				KlingonCruiser.class);
	}

	public ArrayList<SpaceShip> getAttackTargets() {
		return attackTargets;
	}

	public void setModeStandBy() {
		engineMode = ENGINE_MODE_STAND_BY;
		manualStearingEngine = MODE_MANUAL_STEARING_ENGINE_OFF;
		manualStearingRotation = MODE_MANUAL_STEARING_ROTATION_OFF;
		updateControlPanel();
	}

	public void setModeRescue() {
		@SuppressWarnings("unchecked")
		List<SpaceShip> list = getWorld().getObjects(KobayashiMaru.class);
		if (list.size() > 0) {
			setModeStandBy();
			pursuite(list.get(0));
		}
		updateControlPanel();
	}

	public int getNumberOfManeuvers() {
		return maneuvers.size();
	}
	public String getManeuverName(int index) {
		return maneuvers.get(index).getName();
	}

	public void doManeuver(int index) {
		if (index < maneuvers.size()) {
			setModeStandBy();
			List<Location> m = maneuvers.get(index).getPoints();
			canStop = false;
			moveByPath(GeoTools.rotateTranslateNormalize(m, getExactX(),
					getExactY(), getRotation(), getWorld()));
		}
	}

	public void engineOn(boolean engineOn) {
		engineMode = ENGINE_MODE_STAND_BY;
		if (engineOn) {
			manualStearingEngine = MODE_MANUAL_STEARING_ENGINE_ON;
		} else {
			manualStearingEngine = MODE_MANUAL_STEARING_ENGINE_OFF;
		}
		updateControlPanel();
	}

	public int getManualStearingEngine() {
		return manualStearingEngine;
	}

	public int getManualStearingRotation() {
		return manualStearingRotation;
	}

	public void setRotateDirection(int direction) {
		engineMode = ENGINE_MODE_STAND_BY;
		if (direction < 0) {
			manualStearingRotation = MODE_MANUAL_STEARING_ROTATION_LEFT;
		}
		if (direction > 0) {
			manualStearingRotation = MODE_MANUAL_STEARING_ROTATION_RIGHT;
		}
		if (direction == 0) {
			manualStearingRotation = MODE_MANUAL_STEARING_ROTATION_OFF;
		}
		updateControlPanel();
	}

	protected void updateControlPanel() {
		if (getControlPanel() != null) {
			getControlPanel().updateState();
		}
	}

	@Override
	public boolean addAttackTarget(SpaceShip e) {
		boolean b = super.addAttackTarget(e);
		updateControlPanel();
		return b;
	}

	@Override
	public boolean addAttackTargets(Collection<? extends SpaceShip> c) {
		boolean b = super.addAttackTargets(c);
		updateControlPanel();
		return b;
	}

	@Override
	public void removeAttackTarget(SpaceShip e) {
		super.removeAttackTarget(e);
		updateControlPanel();
	}

	@Override
	public void youWasAdded() {
		super.youWasAdded();
		Random rand = new Random();
		for (int i = 0; i < 3; i++) {
			int xPos = rand.nextInt(getWorld().getWidth());
			int border = ((SpaceMap) getWorld()).getBorder();
			int yPos = rand.nextInt(getWorld().getHeight() - border) + border;
			getWorld().addObject(new KlingonCruiser(), xPos, yPos);
		}
		getControlPanel().setEnterprise(this);
	}

	@Override
	public void youWasRemoved(World world) {
		super.youWasRemoved(world);
		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				getControlPanel().setVisible(false);
			}
		});
	}

	@Override
	public void worldWasStarted() {
		super.worldWasStarted();
		getControlPanel().setVisible(true);
	}

	@Override
	public void worldWasStopped() {
		super.worldWasStopped();
		getControlPanel().setVisible(false);
	}

}
