
import java.util.List;

import greenfoot.World;

/**
 * Write a description of class KobayashiMaru here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class KobayashiMaru extends SpaceShip
{
	protected Label timeLabel;
	protected int timeToDestroy = 600;
	protected int timeDealy = 10;
	protected int tickCount = 0;
	protected boolean rescued = false;
	
	
	
	
	/**
     * Act - do whatever the KobayashiMaru wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        super.act();
        tickCount++;
        @SuppressWarnings({ "unchecked" })
		List<Enterprise> enterprieses = getIntersectingObjects(Enterprise.class);
        if(enterprieses.size() > 0){
        	for(Enterprise e : enterprieses){
        		if(GeoTools.getDistance(this, e) < e.getImage().getWidth()/2 + this.getImage().getWidth()/2){
                	rescued = true;
                	break;
        		}
        	}
        	timeLabel.setText("RESCUED");
        }
        else {
        	rescued = false;
        }
        if(!rescued){
	        if(tickCount % timeDealy == 0 ){
	        	tickCount = 0;
	            timeToDestroy--;
	            updateTimeLabel();
	        }
	        if(timeToDestroy == 0){
	        	explode();
	        	return;
	        }
        }
    }

	@Override
	public void setLocation(int x, int y) {
		super.setLocation(x, y);
		if(timeLabel != null){
			timeLabel.setLocation(x + 30, y - 10);
		}
	}

	@Override
	public void setLocation(double x, double y) {
		super.setLocation(x, y);
		if(timeLabel != null){
			timeLabel.setLocation(getX()+30, getY()-10);
		}
	}

	protected void updateTimeLabel(){
    	String time = String.format("%02d:%02d", timeToDestroy/60, timeToDestroy%60);
    	timeLabel.setText(time);
    }
    
	public KobayashiMaru() {
		super();
		setName("Kobiashi Maru");
		//speed =  6;
		//rotationSpeed = 5;
		
	}

	@Override
	public void youWasAdded() {
		super.youWasAdded();
		timeLabel = new Label();
		getWorld().addObject(timeLabel, getX()+30, getY()-10);
		timeLabel.setTextPattern("00:00");
//		double r = (speed/2.0)/Math.cos(Math.PI/180 * ((180-rotationSpeed)/2.0));
//		canStop = false; 
//		setDestination(getX(), (int)(getY()-r));
	}

	@Override
	public void youWasRemoved(World world) {
		super.youWasRemoved(world);
		world.removeObject(timeLabel);
	}
	
	public boolean isRescued(){
		return rescued;
	}
}
