
import greenfoot.Actor;
import greenfoot.GreenfootImage;
import greenfoot.World;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;


/**
 * Write a description of class Label here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Label extends Actor implements WorldListener
{
	private String text;

	private Color background = new Color(255, 255, 255, 0); 
	private Color foreground = new Color(255, 255, 255, 255); 
	
	/**
     * Act - do whatever the Label wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
	
	public void setTextPattern(String text){
		this.text = text;
		recreateLabelImage();
	}

	protected void recreateLabelImage(){
		if(getWorld() != null && text != null){
			FontRenderContext frc = new FontRenderContext(((Graphics2D)(getWorld().getBackground().getAwtImage().getGraphics())).getTransform(), true, false);
			TextLayout tl = new TextLayout(text, getWorld().getBackground().getAwtImage().getGraphics().getFont(), frc);
			Rectangle r = tl.getPixelBounds(frc, 0, 20);
			GreenfootImage image = new GreenfootImage(r.width , r.height);
			setImage(image);
			updateLabelImage();
		}
	}
	protected void updateLabelImage(){
		GreenfootImage image = getImage();
		if(image != null){
			Graphics2D g = (Graphics2D)image.getAwtImage().getGraphics();
			g.setBackground(background);
			g.clearRect(0, 0, image.getWidth(), image.getHeight());
			g.setColor(foreground);
			g.drawString(text, 0, image.getHeight());
		}
	}
	
	public String getText() {
		return text;
	}


	public void setText(String text) {
		this.text = text;
		updateLabelImage();
	}

	public Color getBackground() {
		return background;
	}

	public void setBackground(Color background) {
		this.background = background;
	}

	public Color getForeground() {
		return foreground;
	}

	public void setForeground(Color foreground) {
		this.foreground = foreground;
	}

	@Override
	public void youWasAdded() {
		recreateLabelImage();
	}

	@Override
	public void youWasRemoved(World world) {
	}

	@Override
	public void worldWasStarted() {
	}

	@Override
	public void worldWasStopped() {
	}
}
