
import greenfoot.*;

// (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class LabeledActor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class LabeledActor extends AutonomousMover implements WorldListener
{
	
	protected ObjectLabel label;
	@Override
	public void setLocation(int x, int y) {
		super.setLocation(x, y);
		if(label != null){
				label.setLabelLocation(getLabelX(), getLabelY());
		}
	}

	@Override
	public void setLocation(double x, double y) {
		super.setLocation(x, y);
		if(label != null){
			label.setLabelLocation(getLabelX(), getLabelY());
		}
	}

	@Override
	public void youWasAdded() {
		super.addedToWorld(getWorld());
		getWorld().addObject(getLabel(), getLabelX(), getLabelY());
	}

	@Override
	public void youWasRemoved(World world) {
		world.removeObject(label);
	}

	public ObjectLabel getLabel() {
		if(label == null){
			label = new ObjectLabel(this);
		}
		return label;
	}

	public void setLabel(ObjectLabel label) {
		this.label = label;
	}

	private int getLabelX(){
		return getX()+getImage().getWidth()/2;
	}
	private int getLabelY(){
		return getY() - getImage().getHeight()/2;
	}
	
}
