import greenfoot.GreenfootImage;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;


public class Orbit extends SmoothMover {

	private double radius;
	
	
	
	public Orbit(double radius) {
		super();
		this.radius = radius;
		setImage(new GreenfootImage((int)(2*radius), (int)(2*radius)));
		updateImage();
	}
	
	
	
	public Orbit() {
		this(100);
	}



	protected void updateImage() {
		Graphics2D g = (Graphics2D) getImage().getAwtImage().getGraphics();
		g.setBackground(new Color(255, 255, 255, 0));
		g.clearRect(0, 0, getImage().getWidth(), getImage().getHeight());
			g.setStroke(new BasicStroke(1));
			g.setColor(new Color(0, 255, 255, 150));
			g.drawOval(0, 0, (int)(2*radius),
					(int)(2*radius));
	}
	
	public void setCenterLocation(ExactLocation l){
		setLocation(l.getX(), l.getY());
	}
}
