import greenfoot.Actor;
import greenfoot.GreenfootImage;
import greenfoot.World;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.util.Collection;
import java.util.List;
import java.util.Random;

/**
 * Write a description of class SpaceMap here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SpaceMap extends World
{
	
	protected int border = 150; 
	
	protected boolean lose = false;
	protected boolean win = false;

    /**
     * Constructor for objects of class SpaceMap.
     * 
     */
    public SpaceMap()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 600, 1);
        Graphics2D g = (Graphics2D)getBackground().getAwtImage().getGraphics();
        g.setStroke(new BasicStroke(10));
        g.setColor(new Color(255,0,255,100));
        g.drawLine(0,  border, getWidth(), border);
        g.setFont(g.getFont().deriveFont(Font.BOLD, 30));
        g.drawString("Neutral Zone", getWidth()/2, border);
        Random r = new Random(); 
        addObject(new Enterprise(), 200 + r.nextInt(400), 450+r.nextInt(100));
        addObject(new KobayashiMaru(), 200 + r.nextInt(400), 50+r.nextInt(border - 100));
//        Torpedo t = new Torpedo();
//        addObject(t, 420, 280);
//        t.setDestination(400, 300);
        
    }

	/**
     * An example of a method - replace this comment with your own
     *
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y
     */
    public void addObject(Actor object, int x, int y) 
    {
        super.addObject(object, x, y);
        if(object instanceof WorldListener){
        	((WorldListener)object).youWasAdded();
        }
    }

	@Override
	public void removeObject(Actor object) {
		super.removeObject(object);
        if(object instanceof WorldListener){
        	((WorldListener)object).youWasRemoved(this);
        }
	}

	@Override
	public void removeObjects(Collection objects) {
		super.removeObjects(objects);
		for(Object object : objects){
	        if(object instanceof WorldListener){
	        	((WorldListener)object).youWasRemoved(this);
	        }
		}
	}

    
    @Override
	public void stopped() {
		super.stopped();
		for(Object object : getObjects(WorldListener.class)){
	        if(object instanceof WorldListener){
	        	((WorldListener)object).worldWasStopped();
	        }
		}
	}

    
	@Override
	public void started() {
		super.started();
		for(Object object : getObjects(WorldListener.class)){
	        if(object instanceof WorldListener){
	        	((WorldListener)object).worldWasStarted();
	        }
		}
	}

	public int getBorder(){
		return border;
	}

	@Override
	public void act() {
		super.act();
		if(!lose && ( getObjects(KobayashiMaru.class).size() == 0 || getObjects(Enterprise.class).size() == 0 )){
			lose = true;
			Label lose = new Label();
			lose.setImage(new GreenfootImage("you_lose.png"));
			addObject(lose, getWidth()/2, getHeight()/2);
		}
		if(!win && ( getObjects(KobayashiMaru.class).size() > 0 &&
				getObjects(Enterprise.class).size() > 0 &&
				getObjects(KlingonCruiser.class).size() == 0)){
			boolean allKobayashiMaruRescued = true;
			for(KobayashiMaru k : (List<KobayashiMaru>)getObjects(KobayashiMaru.class)){
				if(!k.isRescued()){
					allKobayashiMaruRescued = false;
					break;
				}
			}
			if(allKobayashiMaruRescued){
				win = true;
				Label win = new Label();
				win.setImage(new GreenfootImage("you_win.png"));
				addObject(win, getWidth()/2, getHeight()/2);
			}
		}
	}
	
	
}
