import greenfoot.World;
/**
 * Write a description of class Torpedo here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Torpedo extends AutonomousMover implements WorldListener
{
    //protected Random rand = new Random();
    protected int power = 10;
    protected boolean klingon = false;
    protected Orbit orbitL;
    protected Orbit orbitR;
    protected boolean showOrbits = false;

    /**
     * Act - do whatever the Torpedo wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    
    public void act() 
    {
    	super.act();
    	
    }
	public Torpedo() {
		this(10, 6, 3, false);
	}
	public Torpedo(int power, float speed, float rotationSpeed, boolean klingon) {
		super();
		canStop = false;
		this.speed = speed;
		this.rotationSpeed = rotationSpeed;
		this.power = power;
		this.klingon = klingon;
		if(klingon){
			setImage("photon_torpedo_green.gif");
		}
		
	}
	@Override
	protected void destinationReached() {
		Explosion ex = new Explosion(klingon);
		ex.setScale(0.3);
		if(engineMode == ENGINE_MODE_DESTINATION_ACTOR){
			((SpaceShip)destination).hit(power);
		}
		if(getWorld() != null){
			getWorld().addObject(ex, getX(), getY());
			getWorld().removeObject(this);
		}
	}
	@Override
	protected void edgeOfWordReached() {
		super.edgeOfWordReached();
		getWorld().removeObject(this);
	}
	public boolean isKlingon() {
		return klingon;
	}
	@Override
	public void youWasAdded() {
		if(showOrbits){
			orbitL = new Orbit(getOrbitRadius());
			orbitR = new Orbit(getOrbitRadius());
			getWorld().addObject(orbitL, 0, 0);
			getWorld().addObject(orbitR, 0, 0);
			updateOrbitLocation();
		}
	}
	protected void updateOrbitLocation(){
		if(orbitL != null){
			orbitL.setCenterLocation(getLeftOrbitCenter());
		}
		if(orbitR != null){
			orbitR.setCenterLocation(getRightOrbitCenter());
		}
	}
	
	@Override
	public void youWasRemoved(World world) {
		world.removeObject(orbitL);
		world.removeObject(orbitR);
	}
	@Override
	public void setLocation(double x, double y) {
		super.setLocation(x, y);
		updateOrbitLocation();
		
	}
	@Override
	public void setLocation(int x, int y) {
		super.setLocation(x, y);
		updateOrbitLocation();
	}
	@Override
	public void worldWasStarted() {
	}
	@Override
	public void worldWasStopped() {
	}
	
}
